#ifndef __PROTO_EVENT_H__
#define __PROTO_EVENT_H__

#include "TimedEvent.h"
#include <cstdio>
#include <string>

class ProtoEvent : public TimedEvent
{
	public:
		ProtoEvent() : index_(-1) {}
		virtual ~ProtoEvent() {}

		virtual void Freeze( FILE *_to_file );
		virtual void UnFreeze( std::string _from_line ) = 0;

		inline long index() { return index_; }

		inline void indexIs( long _index ) { index_ = _index; }

	protected:
		virtual std::string name() = 0;

		long index_;
};

#endif
