#ifndef __PROTO_SMOOTH_H__
#define __PROTO_SMOOTH_H__

#include "ProtoEvent.h"

class ProtoSmooth : public ProtoEvent
{
	public:
		ProtoSmooth( float _force = 1.0f ) : force_(_force) {}
		virtual ~ProtoSmooth() {}

		virtual void Freeze( FILE *_to_file );
		virtual void UnFreeze( std::string _from_line );

		inline void forceIs( float _force ) {
			force_ = _force;
		}

		inline float force() { return force_; }

	protected:
		inline virtual std::string name() { return "Smooth"; }

	private:
		float force_;
};

#endif
