#include "TimedEvent.h"

OrderTimedEvent::OrderTimedEvent(const bool& _reverse) : reverse_(_reverse)
{
}

bool OrderTimedEvent::operator() (
		TimedEvent const * const & lhs, TimedEvent const * const & rhs)
{
	if( reverse_ ) {
		return lhs->startTime() < rhs->startTime();
	}
	return lhs->startTime() > rhs->startTime();
}
