#ifndef __TIMED_EVENT_H__
#define __TIMED_EVENT_H__

class TimedEvent
{
	public:
		TimedEvent() {}
		virtual ~TimedEvent() {}

		inline void startTimeIs( unsigned long _start_time ) {
			start_time_ = _start_time;
		}

		inline unsigned long startTime() const {
			return start_time_;
		}

		inline void endTimeIs( unsigned long _end_time ) {
			end_time_ = _end_time;
		}

		inline unsigned long endTime() const {
			return end_time_;
		}

	protected:
		unsigned long start_time_;
		unsigned long end_time_;
};

class OrderTimedEvent
{
	public:
		OrderTimedEvent(const bool& _reverse=false);

		bool operator() (TimedEvent const * const & lhs,
				TimedEvent const * const & rhs);

	private:
		bool reverse_;
};

#endif
