#ifndef __BLEND_H__
#define __BLEND_H__

#include "TerrainEvent.h"

#include <Terrain/OgreTerrain.h>

class Blend : public TerrainEvent
{
	public:
		virtual void Morph();
		virtual void Morph( float *_height_data );
		virtual ~Blend();

	protected:
		friend class TerrainEvent;
		static Blend *Random( Ogre::Terrain *_terrain );

	private:
		Blend( Ogre::Terrain *_terrain );
};

#endif
