#include "Song.h"

#include "Mad.h"
#include <fcntl.h>

#include <deque>
#include <iostream>

using namespace std;

Song::Song( Ogre::Terrain *_terrain ) : TerrainEvent( _terrain )
{
}

Song *Song::Random( Ogre::Terrain *_terrain )
{
	return new Song( _terrain );
}

Song::~Song()
{
}

// Prep our data_ptr_ (StereoPCM struct) for use.
// SUPER HACKHACK
void Song::Morph()
{
	static const unsigned long centers[][2] =
		{ { 128, 128 }, { 128, 384 }, { 384, 384 }, { 384, 128 } };

	data_ptr_->filename = filename_;

	int fildes = open( data_ptr_->filename.c_str(), O_RDONLY );

	assert( fildes != -1 );

	// TODO Make StereoPCM a proper class that init's itself
	data_ptr_->left = new deque<MAD_SAMPLE>();
	data_ptr_->right = new deque<MAD_SAMPLE>();
	data_ptr_->sample_rate = 0;

	data_ptr_->center_x = centers[index()][0];
	data_ptr_->center_y = centers[index()][1];
	data_ptr_->influence = 192;

	int rv = decode( fildes, data_ptr_ );

	assert( rv == 0 );

	assert( data_ptr_->sample_rate == 44100 );

	return;
}

void Song::Morph( float *_height_data )
{
}
