#ifndef __SONG_H__
#define __SONG_H__

#include "TerrainEvent.h"

#include "StereoPCM.h"

#include <cstring>

class Song : public TerrainEvent
{
	public:
		virtual void Morph();
		virtual void Morph( float *_height_data );
		virtual ~Song();

		inline StereoPCM *dataPtr() { return data_ptr_; }
		inline void dataPtrIs( StereoPCM *_data_ptr ) { data_ptr_ = _data_ptr; }

		inline std::string filename() { return filename_; }
		inline void filenameIs( std::string _filename ) { filename_ = _filename; }

	protected:
		friend class TerrainEvent;
		static Song *Random( Ogre::Terrain *_terrain );

	private:
		Song( Ogre::Terrain *_terrain );

		StereoPCM *data_ptr_;
		std::string filename_;
};

#endif
