#include "ProtoFault.h"

using namespace std;

ProtoFault::ProtoFault(
		float _start_pos, float _end_pos, float _displacement ) :
			start_pos_(_start_pos), end_pos_(_end_pos), displacement_(_displacement)
{
}

ProtoFault::~ProtoFault()
{
}

void ProtoFault::Freeze( FILE *_to_file )
{
	ProtoEvent::Freeze( _to_file );
	fprintf( _to_file, "%lu %lu %.5f %.5f %.5f\n",
			startTime(), endTime(),
			startPos(), endPos(), displacement() );
}

void ProtoFault::UnFreeze( string _from_line )
{
	sscanf( _from_line.c_str(), "Fault %ld %lu %lu %f %f %f\n",
			&index_, &start_time_, &end_time_,
			&start_pos_, &end_pos_, &displacement_ );
}
