#include "ProtoSong.h"

#include <cassert>

void ProtoSong::Freeze( FILE *_to_file )
{
	ProtoEvent::Freeze( _to_file );
	fprintf( _to_file, "%lu %lu \"%s\"\n",
			start_time_, end_time_, filename_.c_str() );
}

void ProtoSong::UnFreeze( std::string _from_string )
{
	sscanf( _from_string.c_str(), "Song %ld %lu %lu",
			&index_, &start_time_, &end_time_ );

	int start = _from_string.find_first_of( '"' )+1;
	int end = _from_string.find_last_of( '"' );

	assert( end > start );

	filename_ = _from_string.substr( start, end - start );
}
