#ifndef __PROTO_SONG_H__
#define __PROTO_SONG_H__

#include "ProtoEvent.h"

class ProtoSong : public ProtoEvent
{
	public:
		ProtoSong( std::string _filename = "" ) : filename_(_filename) {}
		virtual ~ProtoSong() {}

		virtual void Freeze( FILE *_to_file );
		virtual void UnFreeze( std::string _from_string );

		inline std::string filename() { return filename_; }
		inline void filenameIs( std::string _filename ) { filename_ = _filename; }

	protected:
		inline std::string name() { return "Song"; }

	private:
		std::string filename_;
};

#endif
