#ifndef __SMOOTH_H__
#define __SMOOTH_H__

#include "TerrainEvent.h"

#include <Terrain/OgreTerrain.h>

class Smooth : public TerrainEvent
{
	public:
		virtual void Morph();
		virtual void Morph( float *_height_data );
		virtual ~Smooth();

		inline float force() { return force_; }

		inline void forceIs( float _force ) {
			force_ = _force;
		}

	protected:
		friend class TerrainEvent;

		static Smooth *Random( Ogre::Terrain *_terrain );

	private:
		Smooth( Ogre::Terrain *_terrain );

		float AverageNeighborHeight( float *_height_data, int _x, int _y );

		float force_;
};

#endif
